// A0904 Zegar na konsoli monitora - bez wyświetlacza LCD
#include <Wire.h> // biblioteka I2C
#include <RtcDS3231.h> // biblioteka dla DS3231
// i tworzymy obiekt klasy RtcDS3231 o nazwie zegar, 
RtcDS3231<TwoWire> zegar(Wire);

void setup ()   { // jednorazowo na początku pracy programu:
    Serial.begin(9600); //to samo ustaw w Monitorze
    Serial.print("Czas kompilacji to: ");
    Serial.print(__DATE__); // data i czas systemowy
    Serial.print(" godzina "); Serial.println(__TIME__);
    zegar.Begin(); //inicjalizacja obiektu zegara RTC
// teraz tworzymy złożoną zmienną o nazwie czasKompilacji
// (strukturę)  "własnego, zegarowego" typu RtcDateTime
// i wpisujemy do niej czas systemowy komputera
  RtcDateTime czasKompilacji = RtcDateTime(__DATE__, __TIME__);
// Jeszcze raz wyświetlamy (ale w trochę innym formacie)...  
// z pomocą dalej zdefiniowanej funkcji printDateTime()
  Serial.println("Czas kompilacji w nieco innym formacie:");
  printDateTime(czasKompilacji); //wyświetlamy na monitorze... 
  Serial.println(); //... wpisany tam wcześniej czas kompilacji
  //potem jednorazowo sprawdzamy działanie RTC:
  if (!zegar.IsDateTimeValid()) { //jeśli zła praca RTC
    Serial.println("Poprawiony blad w pracy DS3231!");
    zegar.SetDateTime(czasKompilacji); } //poprawiamy to
  if (!zegar.GetIsRunning()) { //jeśli zegar "nie chodzi"
    zegar.SetIsRunning(true);   } // uruchom zegar   
    Serial.println("Zegar RTC zostal uruchomiony");
//teraz odczytujemy czas z RTC do zmiennej "typu zegarowego":
  RtcDateTime czasAktualny = zegar.GetDateTime(); 
  Serial.println("A oto czas z RTC:");
  printDateTime(czasAktualny); Serial.println(); 
  if (czasAktualny < czasKompilacji) { // sprawdzamy
   zegar.SetDateTime(czasKompilacji);  // wpisujemy
   Serial.println("Wpisano do RTC  czas kompilacji");}  
  else if (czasAktualny > czasKompilacji) {
   Serial.println("Czas odczytany z RTC wyglada prawidlowo");}
  else if (czasAktualny == czasKompilacji){
   Serial.println("Dziwny, ale akceptowalny odczyt z RTC"); }
// tu wyłączamy dodatkowe wyjścia DS3231:
  zegar.SetSquareWavePin(DS3231SquareWavePin_ModeNone);
  zegar.Enable32kHzPin(false); 
  Serial.println("To bylo dzialanie funkcji setup()."); 
  Serial.println();  Serial.println(); // 2 puste linie
  Serial.println("A teraz dzialanie petli loop():"); }

void loop () { //podczas pracy w pętli (co ok. 10 sekund):
 if (!zegar.IsDateTimeValid()) { //gdy jakiś błąd pracy RTC
  Serial.println("Jakis problem RTC ze zliczaniem czasu!"); }
// tak czy inaczej - odczytaj czas z RTC i wyświetl na konsoli
 RtcDateTime czasAktualny = zegar.GetDateTime();
 printDateTime(czasAktualny);  Serial.println();
// odczytaj i wyświetl temperaturę: 
 RtcTemperature temp = zegar.GetTemperature(); 
  temp.Print(Serial);   Serial.println("C");
delay(10000); } // czekaj 10 sekund

//poniżej definicja funkcji formatującej i drukującej wynik
#define countof(a) (sizeof(a) / sizeof(a[0]))
void printDateTime(const RtcDateTime& dt) {
 char datestring[20]; //pomocnicza zmienna tekstowa
 snprintf_P(datestring, // formatuj napis
    countof(datestring),
    PSTR("%02u/%02u/%04u %02u:%02u:%02u"),
    dt.Day(),
    dt.Month(),
    dt.Year(),
    dt.Hour(),
    dt.Minute(),
    dt.Second() );
 Serial.print(datestring); } //wyślij do konsoli
